scala.tools.nsc.backend.jvm.BTypes

# BType

#### trait BType extends AnyRef

A BType is either a primitve type, a ClassBType, an ArrayBType of one of these, or a MethodType referring to BTypes.

Source
  BTypes.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
ArrayBType, BOOL, BYTE, CHAR, ClassBType, DOUBLE, FLOAT, INT, LONG, MethodBType, PrimitiveBType, RefBType, SHORT, UNIT
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. BType
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from BType to any2stringadd[BType] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (BType, B)

   Implicit information
     This member is added by an implicit conversion from BType to ArrowAssoc[BType] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### def asArrayBType: ArrayBType

7. #### def asClassBType: ClassBType

8. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

9. #### def asPrimitiveBType: PrimitiveBType

10. #### def asRefBType: RefBType

11. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

12. #### final def conformsTo(other: BType): Boolean

13. #### final def descriptor: String

    returns

      The Java descriptor of this type. Examples:

      - int: I
      - java.lang.String: Ljava/lang/String;
      - int[]: [I
      - Object m(String s, double d): (Ljava/lang/String;D)Ljava/lang/Object;

14. #### def ensuring(cond: (BType) ⇒ Boolean, msg: ⇒ Any): BType

    Implicit information
      This member is added by an implicit conversion from BType to Ensuring[BType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: (BType) ⇒ Boolean): BType

    Implicit information
      This member is added by an implicit conversion from BType to Ensuring[BType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean, msg: ⇒ Any): BType

    Implicit information
      This member is added by an implicit conversion from BType to Ensuring[BType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean): BType

    Implicit information
      This member is added by an implicit conversion from BType to Ensuring[BType] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

19. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

20. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

21. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from BType to StringFormat[BType] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

22. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

23. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

24. #### final def isArray: Boolean

25. #### final def isBoxed: Boolean

26. #### final def isClass: Boolean

27. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

28. #### final def isIntSizedType: Boolean

29. #### final def isIntegralType: Boolean

30. #### final def isMethod: Boolean

31. #### final def isNonVoidPrimitiveType: Boolean

32. #### final def isNothingType: Boolean

33. #### final def isNullType: Boolean

34. #### final def isNumericType: Boolean

35. #### final def isPrimitive: Boolean

36. #### final def isRealType: Boolean

37. #### final def isRef: Boolean

38. #### final def isWideType: Boolean

39. #### final def maxType(other: BType): BType

    Compute the upper bound of two types.

    Compute the upper bound of two types. Takes promotions of numeric primitives into account.

40. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

41. #### final def notify(): Unit

    Definition Classes
      AnyRef

42. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

43. #### final def size: Int

    returns

      0 for void, 2 for long and double, 1 otherwise

44. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

45. #### def toASMType: Type

    The asm.Type corresponding to this BType.

    The asm.Type corresponding to this BType.

    Note about asm.Type.getObjectType (*): For class types, the method expects the internal name, i.e. without the surrounding 'L' and ';'. For array types on the other hand, the method expects a full descriptor, for example "[Ljava/lang/String;".

    See method asm.Type.getType that creates a asm.Type from a type descriptor

    - for an OBJECT type, the 'L' and ';' are not part of the range of the created Type
    - for an ARRAY type, the full descriptor is part of the range

46. #### final def toString(): String

    Definition Classes
      BType → AnyRef → Any

47. #### final def typedOpcode(opcode: Int): Int

    Some JVM opcodes have typed variants.

    Some JVM opcodes have typed variants. This method returns the correct opcode according to the type.

    opcode

      A JVM instruction opcode. This opcode must be one of ILOAD, ISTORE, IALOAD, IASTORE, IADD, ISUB, IMUL, IDIV, IREM, INEG, ISHL, ISHR, IUSHR, IAND, IOR IXOR and IRETURN.

    returns

      The opcode adapted to this java type. For example, if this type is `float` and `opcode` is `IRETURN`, this method returns `FRETURN`.

48. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

49. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

50. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

51. #### def →[B](y: B): (BType, B)

    Implicit information
      This member is added by an implicit conversion from BType to ArrowAssoc[BType] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from BType to any2stringadd[BType]

### Inherited by implicit conversion StringFormat from BType to StringFormat[BType]

### Inherited by implicit conversion Ensuring from BType to Ensuring[BType]

### Inherited by implicit conversion ArrowAssoc from BType to ArrowAssoc[BType]

### Ungrouped